using namespace std;
#include <iostream>
#include <fstream>
#include <math.h>

void ftest( int* npar, double* grad, double* fval, double* xval, 
            int* flag, int* idum );
extern "C" void mintio_( int* ilun, int* olun, int* elun );
extern "C" void minuit_( void (*fcn)( int* npar, double* grad, double* fval,
                                      double* xval, int* flag, int* idum ), 
                         int* idum );
extern "C" void opfile_( int* unit, char* name );

int main() {

  int ilun;
  cout << "unit >> " << flush;
  cin >> ilun;
  if ( ilun != 5 ) {
    char* name = new char[100];
    cout << "file >> " << flush;
    cin >> name;
    opfile_( &ilun, name );
  }

  int olun = 6;
  int elun = 7;
  int idum = 0;
  mintio_( &ilun, &olun, &elun );
  minuit_( ftest, &idum );

  return 0;

}

void ftest( int* npar, double* grad, double* fval, double* xval, 
            int* flag, int* idum ) {
  static float ca;
  static float cb;
  static float cc;
  static float cd;
  static float ce;
  static float cf;
  static float cg;
  if ( *flag == 1 ) {
    ifstream file( "parameters.dat" );
    file >> ca >> cb >> cc >> cd >> ce >> cf >> cg;
    cout << "input parameters: "
         << ca << " " << cb << " " << cc << " " << cd << " "
         << ce << " " << cf << " " << cg << endl;
  }
  *fval = ( ca * pow( xval[0] - cd, 2 ) ) +
          ( cb * pow( xval[1] - ce, 2 ) ) +
          ( cc *    ( xval[0] - cf ) * ( xval[1] - cg ) );
//  cout << "==> " << *flag    << " " << *npar    << " "
//                 <<  xval[0] << " " <<  xval[1] << " " << *fval << endl;
  return;
}

